You can create a bullet sparkline using the BulletSparkline function in a formula: =BULLETSPARKLINE(measure, target, maxi, good?, bad?, forecast?, tickunit?, colorScheme?, vertical?, measureColor?, targetColor?, maxiColor?, goodColor?, badColor?, forecastColor?, allowMeasureOverMaxi?, barSize?).
The function has the following parameters:
measure: Number or reference that represents the length of the measure bar, such as 5 or "A1".
target: Number or reference that represents the location of the target line, such as 7 or "A2".
maxi: Number or reference that represents the maximum value of the sparkline, such as 10 or "A3".
good: (optional) Number or reference that represents the length of the good bar, such as 3 or "A4"; default value is 0.
bad: (optional) Number or reference that represents the length of the bad bar, such as 1 or "A5"; default value is 0.
forecast: (optional) Number or reference that represents the length of the forecast line, such as 8 or "A6"; default value is 0.
tickunit: (optional) Number or reference that represents the tick unit, such as 1 or "A7"; default value is 0.
colorScheme: (optional) String that represents the color scheme for generating a group of colors to display the sparkline; default value is "#A0A0A0".
vertical: (optional) Boolean that represents whether to display the sparkline vertically; default value is false.
measureColor: (optional) String that represents the color of measure bar.
targetColor: (optional) String that represents the color of target line.
maxiColor: (optional) String that represents the maxi area color.
goodColor: (optional) String that represents the good area color.
badColor: (optional) String that represents the bad area color.
forecastColor: (optional) String that represents the forecast line color.
allowMeasureOverMaxi: (optional) Boolean that represents if the measure could exceed maxi area; default value is false.
barSize: (optional) Number that represents that the percentage of bar width/height according to the cell height/ width. (value > 0 && value <= 1)
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
var spreadNS = GC.Spread.Sheets;
let spread = null;
export function AppFunc() {
const [bulletOption, setBulletOption] = React.useState({
colorScheme: '#FFFFFF',
measureColor: '#000000',
targetColor: '#F7A711',
maxiColor: '#DDDDDD',
goodColor: '#BBBBBB',
badColor: '#999999',
forecastColor: '#FFFFFF',
allowMeasureOverMaxi: true,
barSize: '0.7'
});
React.useEffect(() => {
applyChanges();
}, [bulletOption]);
const colorSchemeChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, colorScheme: value });
}
const measureColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, measureColor: value });
}
const targetColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, targetColor: value });
}
const maxiColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, maxiColor: value });
}
const goodColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, goodColor: value });
}
const badColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, badColor: value });
}
const forecastColorChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, forecastColor: value });
}
const allowMeasureOverMaxiChange = (e) => {
let value = e.target.checked;
setBulletOption({ ...bulletOption, allowMeasureOverMaxi: value });
}
const barSizeChange = (e) => {
let value = e.target.value;
setBulletOption({ ...bulletOption, barSize: value });
}
const initHorizontalSparkline = (sheet, name) => {
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 8);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 1, 8).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(3, 1, 6, 7).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(3, 1, 6, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 2, [
['Region', 'Forecast', 'Actual', 'Target', 'Max', 'Optimist F.', 'Pessimist F.', ' '],
['North America', 80, 75, 70, 95, 65, 50],
['South America', 79, 62, 80, 95, 75, 50],
['Europe', 95, 100, 100, 120, 90, 80],
['Azia', 80, 95, 80, 90, 70, 55],
['Australia', 35, 20, 40, 50, 35, 15],
['Africa', 34, 40, 30, 50, 20, 15]
]);
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"#FFFFFF",false,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
for (var i = 3; i < 9; i++) {
sheet.setRowHeight(i, 40);
}
for (var j = 2; j < 9; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.setColumnWidth(1, 250);
sheet.resumePaint();
}
const initVerticalSparkline = (sheet, name) => {
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 7);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 7, 1).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(2, 2, 7, 6).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 7).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(2, 2, 7, 6).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 1, [
['Region', 'North America', 'South America', 'Europe', 'Azia', 'Australia', 'Africa'],
['Forecast', 80, 79, 95, 80, 35, 34],
['Actual', 75, 62, 100, 95, 20, 40],
['Target', 70, 80, 100, 80, 40, 30],
['Max', 95, 95, 120, 90, 50, 50],
['Optimist F.', 65, 75, 90, 70, 35, 20],
['Pessimist F.', 50, 50, 80, 55, 15, 15]
]);
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"#FFFFFF",TRUE,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
sheet.setRowHeight(9, 200);
for (var j = 1; j < 8; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.resumePaint();
}
const applyChanges = () => {
let sheet = spread.getActiveSheet();
if (spread.getActiveSheetIndex() == 0) {
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"' +
bulletOption.colorScheme + '",false,"' +
bulletOption.measureColor + '","' +
bulletOption.targetColor + '","' +
bulletOption.maxiColor + '","' +
bulletOption.goodColor + '","' +
bulletOption.badColor + '","' +
bulletOption.forecastColor + '",' +
bulletOption.allowMeasureOverMaxi + ',' +
bulletOption.barSize);
}
} else if (spread.getActiveSheetIndex() == 1) {
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"' +
bulletOption.colorScheme + '",true,"' +
bulletOption.measureColor + '","' +
bulletOption.targetColor + '","' +
bulletOption.maxiColor + '","' +
bulletOption.goodColor + '","' +
bulletOption.badColor + '","' +
bulletOption.forecastColor + '",' +
bulletOption.allowMeasureOverMaxi + ',' +
bulletOption.barSize);
}
}
}
const initSpread = (currSpread) => {
spread = currSpread;
initHorizontalSparkline(spread.sheets[0], "Horizontal");
initVerticalSparkline(spread.sheets[1], "Vertical");
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)} newTabVisible={false}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel panelInfo={bulletOption}
colorSchemeChange={(e) => { colorSchemeChange(e) }}
measureColorChange={(e) => { measureColorChange(e) }}
targetColorChange={(e) => { targetColorChange(e) }}
maxiColorChange={(e) => { maxiColorChange(e) }}
goodColorChange={(e) => { goodColorChange(e) }}
badColorChange={(e) => { badColorChange(e) }}
forecastColorChange={(e) => { forecastColorChange(e) }}
allowMeasureOverMaxiChange={(e) => { allowMeasureOverMaxiChange(e) }}
barSizeChange={(e) => { barSizeChange(e) }}
/>
</div>
);
}
const Panel = (props) => {
const { panelInfo, colorSchemeChange,
measureColorChange,
targetColorChange,
maxiColorChange,
goodColorChange,
badColorChange,
forecastColorChange,
allowMeasureOverMaxiChange,
barSizeChange } = props;
return (
<div class="options-container">
<div>
<label><b>Settings:</b></label>
</div>
<hr />
<div class="option-row">
<label for="color">Color Scheme:</label>
<select id="color" value={panelInfo.colorScheme + ""} onChange={(e) => { colorSchemeChange(e) }} >
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="measure">Measure Color:</label>
<select id="measure" value={panelInfo.measureColor + ""} onChange={(e) => { measureColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000" selected>Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="target">Target Color:</label>
<select id="target" value={panelInfo.targetColor + ""} onChange={(e) => { targetColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="maxi">Maximum Color:</label>
<select id="maxi" value={panelInfo.maxiColor + ""} onChange={(e) => { maxiColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD" selected>LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="good">Optimist Color:</label>
<select id="good" value={panelInfo.goodColor + ""} onChange={(e) => { goodColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB" selected>Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="bad">Pessimist Color:</label>
<select id="bad" value={panelInfo.badColor + ""} onChange={(e) => { badColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999" selected>DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="forecast">Forecast Color:</label>
<select id="forecast" value={panelInfo.forecastColor + ""} onChange={(e) => { forecastColorChange(e) }} >
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div >
<input type="checkbox" id="allowMeasure" value={panelInfo.allowMeasureOverMaxi + ""} onClick={(e) => { allowMeasureOverMaxiChange(e) }} defaultChecked="true" />
<label for="allowMeasure">Allow Measure Over Max</label>
</div>
<div class="option-row">
<label for="size">Bar Size:</label>
<input type="text" id="size" value={panelInfo.barSize + ""} onChange={(e) => { barSizeChange(e) }} />
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const Component = React.Component;
var spreadNS = GC.Spread.Sheets;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
colorScheme: '#FFFFFF',
measureColor: '#000000',
targetColor: '#F7A711',
maxiColor: '#DDDDDD',
goodColor: '#BBBBBB',
badColor: '#999999',
forecastColor: '#FFFFFF',
allowMeasureOverMaxi: true,
barSize: '0.7'
};
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)} newTabVisible={false}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel panelInfo={this.state}
colorSchemeChange={(e) => { this.colorSchemeChange(e) }}
measureColorChange={(e) => { this.measureColorChange(e) }}
targetColorChange={(e) => { this.targetColorChange(e) }}
maxiColorChange={(e) => { this.maxiColorChange(e) }}
goodColorChange={(e) => { this.goodColorChange(e) }}
badColorChange={(e) => { this.badColorChange(e) }}
forecastColorChange={(e) => { this.forecastColorChange(e) }}
allowMeasureOverMaxiChange={(e) => { this.allowMeasureOverMaxiChange(e) }}
barSizeChange={(e) => { this.barSizeChange(e) }}
/>
</div>
)
}
colorSchemeChange(e) {
let value = e.target.value;
this.setState(() => ({ colorScheme: value }), () => { this.applyChanges() })
}
measureColorChange(e) {
let value = e.target.value;
this.setState(() => ({ measureColor: value }), () => { this.applyChanges() })
}
targetColorChange(e) {
let value = e.target.value;
this.setState(() => ({ targetColor: value }), () => { this.applyChanges() })
}
maxiColorChange(e) {
let value = e.target.value;
this.setState(() => ({ maxiColor: value }), () => { this.applyChanges() })
}
goodColorChange(e) {
let value = e.target.value;
this.setState(() => ({ goodColor: value }), () => { this.applyChanges() })
}
badColorChange(e) {
let value = e.target.value;
this.setState(() => ({ badColor: value }), () => { this.applyChanges() })
}
forecastColorChange(e) {
let value = e.target.value;
this.setState(() => ({ forecastColor: value }), () => { this.applyChanges() })
}
allowMeasureOverMaxiChange(e) {
let value = e.target.checked;
this.setState(() => ({ allowMeasureOverMaxi: value }), () => { this.applyChanges() })
}
barSizeChange(e) {
let value = e.target.value;
this.setState(() => ({ barSize: value }), () => { this.applyChanges() })
}
initHorizontalSparkline(sheet, name) {
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 8);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 1, 8).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(3, 1, 6, 7).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(3, 1, 6, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 2, [
['Region', 'Forecast', 'Actual', 'Target', 'Max', 'Optimist F.', 'Pessimist F.', ' '],
['North America', 80, 75, 70, 95, 65, 50],
['South America', 79, 62, 80, 95, 75, 50],
['Europe', 95, 100, 100, 120, 90, 80],
['Azia', 80, 95, 80, 90, 70, 55],
['Australia', 35, 20, 40, 50, 35, 15],
['Africa', 34, 40, 30, 50, 20, 15]
]);
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"#FFFFFF",false,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
for (var i = 3; i < 9; i++) {
sheet.setRowHeight(i, 40);
}
for (var j = 2; j < 9; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.setColumnWidth(1, 250);
sheet.resumePaint();
}
initVerticalSparkline(sheet, name) {
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 7);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 7, 1).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(2, 2, 7, 6).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 7).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(2, 2, 7, 6).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 1, [
['Region', 'North America', 'South America', 'Europe', 'Azia', 'Australia', 'Africa'],
['Forecast', 80, 79, 95, 80, 35, 34],
['Actual', 75, 62, 100, 95, 20, 40],
['Target', 70, 80, 100, 80, 40, 30],
['Max', 95, 95, 120, 90, 50, 50],
['Optimist F.', 65, 75, 90, 70, 35, 20],
['Pessimist F.', 50, 50, 80, 55, 15, 15]
]);
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"#FFFFFF",TRUE,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
sheet.setRowHeight(9, 200);
for (var j = 1; j < 8; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.resumePaint();
}
applyChanges() {
let sheet = this.spread.getActiveSheet();
if (this.spread.getActiveSheetIndex() == 0) {
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"' +
this.state.colorScheme + '",false,"' +
this.state.measureColor + '","' +
this.state.targetColor + '","' +
this.state.maxiColor + '","' +
this.state.goodColor + '","' +
this.state.badColor + '","' +
this.state.forecastColor + '",' +
this.state.allowMeasureOverMaxi + ',' +
this.state.barSize);
}
} else if (this.spread.getActiveSheetIndex() == 1) {
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"' +
this.state.colorScheme + '",true,"' +
this.state.measureColor + '","' +
this.state.targetColor + '","' +
this.state.maxiColor + '","' +
this.state.goodColor + '","' +
this.state.badColor + '","' +
this.state.forecastColor + '",' +
this.state.allowMeasureOverMaxi + ',' +
this.state.barSize);
}
}
}
initSpread(spread) {
this.spread = spread;
this.initHorizontalSparkline(spread.sheets[0], "Horizontal");
this.initVerticalSparkline(spread.sheets[1], "Vertical");
}
}
const Panel = (props) => {
const { panelInfo, colorSchemeChange,
measureColorChange,
targetColorChange,
maxiColorChange,
goodColorChange,
badColorChange,
forecastColorChange,
allowMeasureOverMaxiChange,
barSizeChange } = props;
return (
<div class="options-container">
<div>
<label><b>Settings:</b></label>
</div>
<hr />
<div class="option-row">
<label for="color">Color Scheme:</label>
<select id="color" value={panelInfo.colorScheme + ""} onChange={(e) => { colorSchemeChange(e) }} >
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="measure">Measure Color:</label>
<select id="measure" value={panelInfo.measureColor + ""} onChange={(e) => { measureColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000" selected>Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="target">Target Color:</label>
<select id="target" value={panelInfo.targetColor + ""} onChange={(e) => { targetColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="maxi">Maximum Color:</label>
<select id="maxi" value={panelInfo.maxiColor + ""} onChange={(e) => { maxiColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD" selected>LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="good">Optimist Color:</label>
<select id="good" value={panelInfo.goodColor + ""} onChange={(e) => { goodColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB" selected>Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="bad">Pessimist Color:</label>
<select id="bad" value={panelInfo.badColor + ""} onChange={(e) => { badColorChange(e) }} >
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999" selected>DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="forecast">Forecast Color:</label>
<select id="forecast" value={panelInfo.forecastColor + ""} onChange={(e) => { forecastColorChange(e) }} >
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div >
<input type="checkbox" id="allowMeasure" value={panelInfo.allowMeasureOverMaxi + ""} onClick={(e) => { allowMeasureOverMaxiChange(e) }} defaultChecked="true" />
<label for="allowMeasure">Allow Measure Over Max</label>
</div>
<div class="option-row">
<label for="size">Bar Size:</label>
<input type="text" id="size" value={panelInfo.barSize + ""} onChange={(e) => { barSizeChange(e) }} />
</div>
</div>
)
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can create a bullet sparkline using the BulletSparkline function in a formula: =BULLETSPARKLINE(measure, target, maxi, good?, bad?, forecast?, tickunit?, colorScheme?, vertical?, measureColor?, targetColor?, maxiColor?, goodColor?, badColor?, forecastColor?, allowMeasureOverMaxi?, barSize?).
The function has the following parameters:
measure: Number or reference that represents the length of the measure bar, such as 5 or "A1".
target: Number or reference that represents the location of the target line, such as 7 or "A2".
maxi: Number or reference that represents the maximum value of the sparkline, such as 10 or "A3".
good: (optional) Number or reference that represents the length of the good bar, such as 3 or "A4"; default value is 0.
bad: (optional) Number or reference that represents the length of the bad bar, such as 1 or "A5"; default value is 0.
forecast: (optional) Number or reference that represents the length of the forecast line, such as 8 or "A6"; default value is 0.
tickunit: (optional) Number or reference that represents the tick unit, such as 1 or "A7"; default value is 0.
colorScheme: (optional) String that represents the color scheme for generating a group of colors to display the sparkline; default value is "#A0A0A0".
vertical: (optional) Boolean that represents whether to display the sparkline vertically; default value is false.
measureColor: (optional) String that represents the color of measure bar.
targetColor: (optional) String that represents the color of target line.
maxiColor: (optional) String that represents the maxi area color.
goodColor: (optional) String that represents the good area color.
badColor: (optional) String that represents the bad area color.
forecastColor: (optional) String that represents the forecast line color.
allowMeasureOverMaxi: (optional) Boolean that represents if the measure could exceed maxi area; default value is false.
barSize: (optional) Number that represents that the percentage of bar width/height according to the cell height/ width. (value > 0 && value <= 1)
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread" :newTabVisible=false>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div>
<label><b>Settings:</b></label>
</div>
<hr>
<div class="option-row">
<label for="scheme">Color Scheme:</label>
<select id="scheme" v-model="colorScheme" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="measure">Measure Color:</label>
<select id="measure" v-model="measureColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000" selected>Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="target">Target Color:</label>
<select id="target" v-model="targetColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="maxi">Maximum Color:</label>
<select id="maxi" v-model="maxiColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD" selected>LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="optimist">Optimist Color:</label>
<select id="optimist" v-model="goodColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB" selected>Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="pessimist">Pessimist Color:</label>
<select id="pessimist" v-model="badColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999" selected>DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="forecast">Forecast Color:</label>
<select id="forecast" v-model="forecastColor" v-on:change="applyChanges" style="margin: 0 20px 0 6px">
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div style="padding-top: 16px">
<input type="checkbox" id="allowMeasure" v-model="allowMeasureOverMaxi" v-on:change="applyChanges"
checked="checked" />
<label for="allowMeasure">Allow Measure Over Max</label>
</div>
<div class="option-row">
<label for="size">Bar Size:</label>
<input type="text" style="margin: 0 20px 0 6px;width:120px;" id="size" v-model="barSize"
v-on:change="applyChanges" />
</div>
</div>
</div>
</template>
<script setup>
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-vue'
const spreadRef = ref(null);
let colorScheme = '#FFFFFF';
let measureColor = '#000000';
let targetColor = '#F7A711';
let maxiColor = '#DDDDDD';
let goodColor = '#BBBBBB';
let badColor = '#999999';
let forecastColor = '#FFFFFF';
let allowMeasureOverMaxi = true;
let barSize = '0.7';
let initHorizontalSparkline = function (sheet, name) {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 8);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 1, 8).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(3, 1, 6, 7).font("20px").vAlign(spreadNS.VerticalAlign.center);
sheet.getRange(2, 1, 7, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(3, 1, 6, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 2, [
['Region', 'Forecast', 'Actual', 'Target', 'Max', 'Optimist F.', 'Pessimist F.', ' '],
['North America', 80, 75, 70, 95, 65, 50],
['South America', 79, 62, 80, 95, 75, 50],
['Europe', 95, 100, 100, 120, 90, 80],
['Azia', 80, 95, 80, 90, 70, 55],
['Australia', 35, 20, 40, 50, 35, 15],
['Africa', 34, 40, 30, 50, 20, 15]
]);
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"#FFFFFF",false,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
for (var i = 3; i < 9; i++) {
sheet.setRowHeight(i, 40);
}
for (var j = 2; j < 9; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.setColumnWidth(1, 250);
sheet.resumePaint();
}
let initVerticalSparkline = function (sheet, name) {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 7);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 7, 1).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(2, 2, 7, 6).font("20px").vAlign(spreadNS.VerticalAlign.center);
sheet.getRange(2, 1, 7, 7).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(2, 2, 7, 6).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 1, [
['Region', 'North America', 'South America', 'Europe', 'Azia', 'Australia', 'Africa'],
['Forecast', 80, 79, 95, 80, 35, 34],
['Actual', 75, 62, 100, 95, 20, 40],
['Target', 70, 80, 100, 80, 40, 30],
['Max', 95, 95, 120, 90, 50, 50],
['Optimist F.', 65, 75, 90, 70, 35, 20],
['Pessimist F.', 50, 50, 80, 55, 15, 15]
]);
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"#FFFFFF",TRUE,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
sheet.setRowHeight(9, 200);
for (var j = 1; j < 8; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.resumePaint();
}
let applyChanges = function () {
var spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
if (spread.getActiveSheetIndex() == 0) {
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ',' +
'$F' + (index + 1) + ',' +
'$G' + (index + 1) + ',' +
'$H' + (index + 1) + ',' +
'$I' + (index + 1) + ',' +
'$D' + (index + 1) + ',1,"' +
colorScheme + '",false,"' +
measureColor + '","' +
targetColor + '","' +
maxiColor + '","' +
goodColor + '","' +
badColor + '","' +
forecastColor + '",' +
allowMeasureOverMaxi + ',' +
barSize);
}
} else {
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,' +
'$' + columnChar + '6,' +
'$' + columnChar + '7,' +
'$' + columnChar + '8,' +
'$' + columnChar + '9,' +
'$' + columnChar + '4,1,"' +
colorScheme + '",true,"' +
measureColor + '","' +
targetColor + '","' +
maxiColor + '","' +
goodColor + '","' +
badColor + '","' +
forecastColor + '",' +
allowMeasureOverMaxi + ',' +
barSize);
}
}
sheet.resumePaint();
}
let initSpread = function (spread) {
spreadRef.value = spread;
initHorizontalSparkline(spread.sheets[0], "Horizontal");
initVerticalSparkline(spread.sheets[1], "Vertical");
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can create a bullet sparkline using the BulletSparkline function in a formula: =BULLETSPARKLINE(measure, target, maxi, good?, bad?, forecast?, tickunit?, colorScheme?, vertical?, measureColor?, targetColor?, maxiColor?, goodColor?, badColor?, forecastColor?, allowMeasureOverMaxi?, barSize?).
The function has the following parameters:
measure: Number or reference that represents the length of the measure bar, such as 5 or "A1".
target: Number or reference that represents the location of the target line, such as 7 or "A2".
maxi: Number or reference that represents the maximum value of the sparkline, such as 10 or "A3".
good: (optional) Number or reference that represents the length of the good bar, such as 3 or "A4"; default value is 0.
bad: (optional) Number or reference that represents the length of the bad bar, such as 1 or "A5"; default value is 0.
forecast: (optional) Number or reference that represents the length of the forecast line, such as 8 or "A6"; default value is 0.
tickunit: (optional) Number or reference that represents the tick unit, such as 1 or "A7"; default value is 0.
colorScheme: (optional) String that represents the color scheme for generating a group of colors to display the sparkline; default value is "#A0A0A0".
vertical: (optional) Boolean that represents whether to display the sparkline vertically; default value is false.
measureColor: (optional) String that represents the color of measure bar.
targetColor: (optional) String that represents the color of target line.
maxiColor: (optional) String that represents the maxi area color.
goodColor: (optional) String that represents the good area color.
badColor: (optional) String that represents the bad area color.
forecastColor: (optional) String that represents the forecast line color.
allowMeasureOverMaxi: (optional) Boolean that represents if the measure could exceed maxi area; default value is false.
barSize: (optional) Number that represents that the percentage of bar width/height according to the cell height/ width. (value > 0 && value <= 1)
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
colorScheme = '#FFFFFF';
measureColor = '#000000';
targetColor = '#F7A711';
maxiColor = '#DDDDDD';
goodColor = '#BBBBBB';
badColor = '#999999';
forecastColor = '#FFFFFF';
allowMeasureOverMaxi = true;
barSize = '0.7';
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
colorSchemeChanges(e: any) {
let value = e.target.value;
this.colorScheme = value;
this.applyChanges();
}
measureColorChanges(e: any) {
let value = e.target.value;
this.measureColor = value;
this.applyChanges();
}
targetColorChanges(e: any) {
let value = e.target.value;
this.targetColor = value;
this.applyChanges();
}
maxiColorChanges(e: any) {
let value = e.target.value;
this.maxiColor = value;
this.applyChanges();
}
goodColorChanges(e: any) {
let value = e.target.value;
this.goodColor = value;
this.applyChanges();
}
badColorChanges(e: any) {
let value = e.target.value;
this.badColor = value;
this.applyChanges();
}
forecastColorChanges(e: any) {
let value = e.target.value;
this.forecastColor = value;
this.applyChanges();
}
allowMeasureOverMaxiChanges(e: any) {
let value = e.target.checked;
this.allowMeasureOverMaxi = value;
this.applyChanges();
}
barSizeChanges(e: any) {
let value = e.target.value;
this.barSize = value;
this.applyChanges();
}
initHorizontalSparkline(sheet: GC.Spread.Sheets.Worksheet, name: string) {
var spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 8);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 1, 8).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(3, 1, 6, 7).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(3, 1, 6, 8).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 2, [
['Region', 'Forecast', 'Actual', 'Target', 'Max', 'Optimist F.','Pessimist F.',' '],
['North America', 80, 75, 70, 95, 65, 50],
['South America', 79, 62, 80, 95, 75, 50],
['Europe', 95, 100, 100, 120, 90, 80],
['Azia', 80, 95, 80, 90, 70, 55],
['Australia', 35, 20, 40,50, 35, 15],
['Africa', 34, 40, 30,50, 20, 15]
]);
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ','+
'$F' + (index + 1) +','+
'$G' + (index + 1) +','+
'$H' + (index + 1) + ','+
'$I' + (index + 1) + ','+
'$D' + (index + 1) + ',1,"#FFFFFF",false,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
for (var i = 3; i < 9; i++) {
sheet.setRowHeight(i, 40);
}
for (var j = 2; j < 9; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.setColumnWidth(1, 250);
sheet.resumePaint();
}
initVerticalSparkline(sheet: GC.Spread.Sheets.Worksheet, name: string) {
var spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.addSpan(1, 1, 1, 7);
sheet.getCell(1, 1).value("Revenue By Region (million $)")
.font("20px Calibri").hAlign(spreadNS.HorizontalAlign.center).vAlign(spreadNS.VerticalAlign.center)
.foreColor("white").backColor("#82bc00");
sheet.getRange(2, 1, 7, 1).vAlign(spreadNS.VerticalAlign.center)
.font("bold 16px Calibri")
.backColor("#F4F8EB");
sheet.getRange(2, 2, 7, 6).font("20px").vAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(2, 1, 7, 7).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.thin), {
all: true
});
sheet.getRange(2, 2, 7, 6).setBorder(new GC.Spread.Sheets.LineBorder("Black", GC.Spread.Sheets.LineStyle.dotted), {
inside: true
});
sheet.setArray(2, 1, [
['Region', 'North America', 'South America', 'Europe', 'Azia', 'Australia','Africa'],
['Forecast', 80, 79, 95, 80, 35, 34],
['Actual', 75, 62, 100, 95, 20, 40],
['Target',70, 80, 100, 80, 40, 30],
['Max',95, 95, 120, 90, 50, 50],
['Optimist F.', 65, 75, 90,70, 35, 20],
['Pessimist F.', 50, 50, 80,55, 15, 15]
]);
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,'+
'$' + columnChar +'6,'+
'$' + columnChar +'7,'+
'$' + columnChar + '8,'+
'$' + columnChar + '9,'+
'$' + columnChar + '4,1,"#FFFFFF",TRUE,"#000000","#F7A711","#DDDDDD","#BBBBBB","#999999","#FFFFFF",TRUE,0.7');
}
sheet.setRowHeight(1, 30);
sheet.setRowHeight(9, 200);
for (var j = 1; j < 8; j++) {
sheet.setColumnWidth(j, 100);
}
sheet.resumePaint();
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
this.initHorizontalSparkline(spread.sheets[0], "Horizontal");
this.initVerticalSparkline(spread.sheets[1], "Vertical");
}
applyChanges() {
let sheet = this.spread.getActiveSheet();
if (this.spread.getActiveSheetIndex() == 0) {
for (var index = 3; index < 9; index++) {
sheet.setFormula(index, 1, '=BULLETSPARKLINE($E' + (index + 1) + ','+
'$F' + (index + 1) +','+
'$G' + (index + 1) +','+
'$H' + (index + 1) + ','+
'$I' + (index + 1) + ','+
'$D' + (index + 1) + ',1,"' +
this.colorScheme + '",false,"'+
this.measureColor + '","'+
this.targetColor + '","'+
this.maxiColor + '","'+
this.goodColor + '","'+
this.badColor + '","'+
this.forecastColor +'",'+
this.allowMeasureOverMaxi +','+
this.barSize);
}
} else if (this.spread.getActiveSheetIndex() == 1) {
for (var index = 2; index < 8; index++) {
var columnChar = String.fromCharCode(65 + index);
sheet.setFormula(9, index, '=BULLETSPARKLINE($' + columnChar + '5,'+
'$' + columnChar +'6,'+
'$' + columnChar +'7,'+
'$' + columnChar + '8,'+
'$' + columnChar + '9,'+
'$' + columnChar + '4,1,"' +
this.colorScheme + '",true,"'+
this.measureColor + '","'+
this.targetColor + '","'+
this.maxiColor + '","'+
this.goodColor + '","'+
this.badColor + '","'+
this.forecastColor +'",'+
this.allowMeasureOverMaxi +','+
this.barSize);
}
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)" [newTabVisible] = false>
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div>
<label><b>Settings:</b></label>
</div>
<hr>
<div class="option-row">
<label for="colorScheme">Color Scheme:</label>
<select id="colorScheme" [value]="colorScheme" (change) = "colorSchemeChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="measureColor">Measure Color:</label>
<select id="measureColor" [value]="measureColor" (change) = "measureColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000" selected>Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="targetColor">Target Color:</label>
<select id="targetColor" [value]="targetColor" (change) = "targetColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="maxiColor">Maximum Color:</label>
<select id="maxiColor" [value]="maxiColor" (change) = "maxiColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD" selected>LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="goodColor">Optimist Color:</label>
<select id="goodColor" [value]="goodColor" (change) = "goodColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB" selected>Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="badColor">Pessimist Color:</label>
<select id="badColor" [value]="badColor" (change) = "badColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF">White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999" selected>DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div class="option-row">
<label for="forecastColor">Forecast Color:</label>
<select id="forecastColor" [value]="forecastColor" (change) = "forecastColorChanges($event)" style="margin: 0 20px 0 6px">
<option value="#FFFFFF" selected>White</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
<option value="#DDDDDD">LightGrey</option>
<option value="#BBBBBB">Grey</option>
<option value="#999999">DarkGrey</option>
<option value="#82BC00">Green</option>
</select>
</div>
<div style="padding-top: 16px">
<input type="checkbox" id="allowMeasureOverMaxi" [value]="allowMeasureOverMaxi" (change) = "allowMeasureOverMaxiChanges($event)" checked="checked"/>
<label for="allowMeasureOverMaxi">Allow Measure Over Max</label>
</div>
<div class="option-row">
<label for="barSize">Bar Size:</label>
<input type="text" style="margin: 0 20px 0 6px;width:120px;" id="barSize" [value]="barSize" (change) = "barSizeChanges($event)" />
</div>
</div>
</div>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 12px;
}
input,
select {
padding: 4px 6px;
box-sizing: border-box;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);